leetcode-486-Predict the Winner

Given an array of scores that are non-negative integers. Player 1 picks one of the numbers from either end of the array followed by the player 2 and then player 1 and so on. Each time a player picks a number, that number will not be available for the next player. This continues until all the scores have been chosen. The player with the maximum score wins.

Given an array of scores, predict whether player 1 is the winner. You can assume each player plays to maximize his score.

Example 1:

Input: [1, 5, 2]
Output: False
Explanation: Initially, player 1 can choose between 1 and 2. If he chooses 2 (or 1), then player 2 can choose from 1 (or 2) and 5. If player 2 chooses 5, then player 1 will be left with 1 (or 2). So, final score of player 1 is 1 + 2 = 3, and player 2 is 5. Hence, player 1 will never be the winner and you need to return False.

Example 2:

Input: [1, 5, 233, 7]
Output: True
Explanation: Player 1 first chooses 1. Then player 2 have to choose between 5 and 7. No matter which number player 2 choose, player 1 can choose 233.Finally, player 1 has more score (234) than player 2 (12), so you need to return True representing player1 can win.

Note:

  1. 1 <= length of the array <= 20.
  2. Any scores in the given array are non-negative integers and will not exceed 10,000,000.
  3. If the scores of both players are equal, then player 1 is still the winner.

思路:

参考自

http://www.voidcn.com/blog/starstar1992/article/p-6497962.html

https://discuss.leetcode.com/topic/76472/clean-3ms-c-dp-solution-with-detailed-explanation

https://discuss.leetcode.com/topic/76327/c-dp-solution-with-explanation

bool PredictTheWinner(vector<int>& nums)
     {
         int n = nums.size();
         vector<vector<int>>dp(n, vector<int>(n));
         vector<int>sum(n);
         sum[0] = nums[0];
         dp[0][0] = nums[0];
         for (int i = 1; i < n;i++)
         {
             sum[i] += sum[i - 1] + nums[i];
             dp[i][i] = nums[i];
         }
         for (int i = 1; i < n;i++)
         {
             for (int j = 0; i + j < n;j++)
             {
                 dp[j][i + j] = max(sum[i+j]-sum[j]+nums[j] -dp[j+1][i+j],sum[i+j]-sum[j]+nums[j]-dp[j][i+j-1]);
             }
         }
         return 2 * dp[0][n - 1] >= sum[n - 1];
     }

如上图所示,dp为二维数组,最终要求得是dp[0][n-1]那么,需要不断的去迭代更新dp[i][j]的值。求得过程类似上图,从对角线的上方

从左上到右下求dp[i][j]的值。也就是说求dp[i][j]需要用到它左边和下边的值 即左边dp[i][j-1]和下边dp[i+1][j]的值。

这一题用动态规划来解决。 
对于原数组A[0,….,n-1],我们定义 
dp[i][j]表示原数组中从i到j的这么多数中,按照游戏规则,某个玩家所能获得的最大分数。 
假设这个分数此时属于palyer1,那么dp[i+1][j]或者dp[i][j-1]表示player2玩家所能获得的最大分数。因为对于player1来讲,他第一次选择要么是第i个数,要么是第j个数,所以对于player2来讲,就分两种情况取最大。

另外我们设从i到j的所有数的和是sum[i,j],则可以得到递推公式:(动态规划最明显的标识) 
dp[i][j]=max(sum[i+1][j]-dp[i+1][j]+nums[i], sum[i][j-1]-dp[i][j-1]+nums[j]) 。

这个需要好好想想!其实不难! 
化简一下: 
dp[i][j]=max(sum[i][j]-dp[i+1][j], sum[i][j]-dp[i][j-1]) 。

但是写代码实现时,我们要注意: 
首先要得到dp[i][i]的值,之后依次得到: 
dp[0][1],dp[1,2],dp[2,3]…dp[n-2][n-1] 
之后再得到dp[0][2],dp[1][3],…

for(int i=1;i<n;i++)
            for(int j=0;i+j<n;j++)
                dp[j][i+j]=max(sum[i+j]-sum[j]+nums[j]-dp[j+1][i+j],sum[i+j]-sum[j]+nums[j]-dp[j][i+j-1]);

所以这段代码的实现意图就比较明显了! 
另外,注意sum[i+j]-sum[j]+nums[j]而不用sum[i+j]-sum[j-1]来求解从i到j的和,是为了考虑j=0时的情况。

细节处比较多,很考察能力!

时间: 2024-10-26 04:02:32

leetcode-486-Predict the Winner的相关文章

LN : leetcode 486 Predict the Winner

lc 486 Predict the Winner 486 Predict the Winner Given an array of scores that are non-negative integers. Player 1 picks one of the numbers from either end of the array followed by the player 2 and then player 1 and so on. Each time a player picks a

随手练——博弈论入门 leetcode - 486. Predict the Winner

题目链接:https://leetcode.com/problems/predict-the-winner/ 1.暴力递归 当前数组左边界:i,右边界:j: 对于先发者来说,他能取到的最大值是:max(arr[i] + second(arr, i + 1, j), arr[j] + second(arr, i, j - 1)); (arr[i] + 作为后发者,在 i+1 到 j 上取得的值),(arr[j] + 作为后发者,在 i 到 j-1 上取得的值) 中大的一个. 对于后发者来说,他是被

LC 486. Predict the Winner

Given an array of scores that are non-negative integers. Player 1 picks one of the numbers from either end of the array followed by the player 2 and then player 1 and so on. Each time a player picks a number, that number will not be available for the

[Leetcode] DP-- 486. Predict the Winner

Given an array of scores that are non-negative integers. Player 1 picks one of the numbers from either end of the array followed by the player 2 and then player 1 and so on. Each time a player picks a number, that number will not be available for the

486. Predict the Winner

Given an array of scores that are non-negative integers. Player 1 picks one of the numbers from either end of the array followed by the player 2 and then player 1 and so on. Each time a player picks a number, that number will not be available for the

[LeetCode] Predict the Winner 预测赢家

Given an array of scores that are non-negative integers. Player 1 picks one of the numbers from either end of the array followed by the player 2 and then player 1 and so on. Each time a player picks a number, that number will not be available for the

【leetcode】1275. Find Winner on a Tic Tac Toe Game

题目如下: Tic-tac-toe is played by two players A and B on a 3 x 3 grid. Here are the rules of Tic-Tac-Toe: Players take turns placing characters into empty squares (" "). The first player A always places "X" characters, while the second pl

leetcode486 Predict the Winner

思路: 博弈. 实现: 1 class Solution 2 { 3 public: 4 5 bool PredictTheWinner(vector<int>& nums) 6 { 7 int dp[21][21]; 8 int n = nums.size(); 9 for (int i = 0; i < n; i++) dp[i][i] = nums[i]; 10 for (int i = n - 1; i >= 0; i--) 11 { 12 for (int j =

LeetCode 486. 预测赢家

给定一个表示分数的非负整数数组. 玩家1从数组任意一端拿取一个分数,随后玩家2继续从剩余数组任意一端拿取分数,然后玩家1拿,…….每次一个玩家只能拿取一个分数,分数被拿取之后不再可取.直到没有剩余分数可取时游戏结束.最终获得分数总和最多的玩家获胜. 给定一个表示分数的数组,预测玩家1是否会成为赢家.你可以假设每个玩家的玩法都会使他的分数最大化. 示例 1: 输入: [1, 5, 2]输出: False解释: 一开始,玩家1可以从1和2中进行选择.如果他选择2(或者1),那么玩家2可以从1(或者2

LeetCode Problems List 题目汇总

No. Title Level Rate 1 Two Sum Medium 17.70% 2 Add Two Numbers Medium 21.10% 3 Longest Substring Without Repeating Characters Medium 20.60% 4 Median of Two Sorted Arrays Hard 17.40% 5 Longest Palindromic Substring Medium 20.70% 6 ZigZag Conversion Ea